/************************/
/*	Applet "alttext"	*/
/************************/

/* Auteur : Serge Delbono (sdelbono@mygale.org) */
/* Copyright Serge Delbono 1996 */
/* FREEWARE */

/* Appel */
/*
<applet code="alttext" width=... Height=...>
	<Param Name=text" Value=...> Texte primaire a afficher
	<Param Name="text2" Value=...> Second texte a afficher
	<Param Name="align" Value=...> Alignement ("left", "right" ou "center")
	<Param Name="font" Value=...> Fonte d'affichage
	<Param Name="fontsize" Value=...> Taille de la fonte
	<Param Name="fgcolor" Value=...> couleur d'criture
	<Param Name="bgcolor" Value=...> couleur de fond
Valeurs par defaut : "Qui c'est le plus beau", "Serge Delbono", "left",
"TimesRoman", "12", "0,0,0" (black), "192,192,192" (gray).

</applet>
*/
import java.io.InputStream;
import java.awt.*;
import java.applet.*;
import java.util.Vector;
import java.util.StringTokenizer ;
import java.io.File;
import java.net.URL;
import java.net.MalformedURLException ;

public class alttext extends java.applet.Applet {

	URL urlDocument ;	// On est la...
	String text, text2 ;
	Font f ;
	FontMetrics fm ;
	int align ;
	int largeur, baseline ;
	Color fgcolor, bgcolor ;
	int pos1, pos2 ;
	boolean actif = false ;
	public synchronized void init() {
		urlDocument = getDocumentBase() ;
		actif = false ;
		text =	getParameter("text") ;
		if (text == null || text == "")
			text = "Qui c'est le plus beau ?" ;
		text2 =	getParameter("text2") ;
		if (text2 == null || text2 == "")
			text2 = "C'est Serge Delbono !" ;
		String salign = getParameter("align") ;
		salign = salign.toLowerCase() ;
//		System.out.println(salign);
		align = 0 ;
		if (salign.equals("center"))
			align = 1 ;
		if (salign.equals("right"))
			align = 2 ;
		
		fgcolor = getCoul(getParameter("fgcolor"),Color.black) ;
		bgcolor = getCoul(getParameter("bgcolor"),Color.lightGray) ;
		String fonte = getParameter("font") ;
		if (fonte == null || fonte == "")
			fonte ="TimesRoman" ;
		String sfsz = getParameter("fontsize") ;
		int fsz ;
		if (sfsz == null || sfsz=="")
			sfsz = "12" ;
		try {fsz = new Integer(sfsz).intValue();} catch (NumberFormatException zob) {fsz=12;} ;
		f = new Font (fonte, Font.PLAIN,fsz) ;
		fm = getFontMetrics(f) ;
		baseline = fm.getAscent() ;
		switch (align) {
			case 0:	pos1 = 0 ; pos2 = 0 ; // left
				break ;
			case 1: // center
				pos1 = (this.size().width - fm.stringWidth(text))/2 ;
				pos2 = (this.size().width - fm.stringWidth(text2))/2 ;
				break ;
			case 2: // right
				pos1 = this.size().width - fm.stringWidth(text) ;
				pos2 = this.size().width - fm.stringWidth(text2) ;
				break ;
		}
		System.out.print ("align : ") ;
//		System.out.print (align) ;
//		System.out.print (" baseline : ") ;
//		System.out.print (baseline) ;
//		System.out.print (" Pos1 : ") ;
//		System.out.print (pos1) ;
//		System.out.print (" Pos2 : ") ;
//		System.out.println (pos2) ;
		setBackground(bgcolor) ;
		setForeground(fgcolor) ;
		repaint() ;
	}
	
	Color getCoul(String coul, Color defaut) {
		int r, g, b ;
		String ch ;
		if (coul==null) return defaut ;
		StringTokenizer st = new StringTokenizer(coul,",") ;
		if (st.hasMoreTokens()) {
			ch = st.nextToken() ;
			try {r = new Integer(ch).intValue();} catch (NumberFormatException zob) {return defaut;} ;
		} else return defaut ;
		if (st.hasMoreTokens()) {
			ch = st.nextToken() ;
			try {g = new Integer(ch).intValue();} catch (NumberFormatException zob) {return defaut;} ;
		} else return defaut ;
		if (st.hasMoreTokens()) {
			ch = st.nextToken() ;
			try {b = new Integer(ch).intValue();} catch (NumberFormatException zob) {return defaut;} ;
		} else return defaut ;
//		System.out.print("Couleur = ") ;
//		System.out.print(r) ;
//		System.out.print(", ") ;
//		System.out.print(g) ;
//		System.out.print(", ") ;
//		System.out.println(b) ;
		return new Color(r,g,b) ;
	}
	public void start() {
	}
	public void stop() {
	}
	public synchronized void paint(Graphics g){
		g.setFont(f) ;
		setBackground(bgcolor) ;
		setForeground(fgcolor) ;
		if (!actif){
//			System.out.println("Normal : " + text) ;
			g.drawString(text,pos1,baseline) ;
		} else {
//			System.out.println("Alt : "+text2) ;
			g.drawString(text2,pos2,baseline) ;
		}
		
	}
	
	public synchronized boolean mouseDown(Event e, int x, int y){
		actif = true ;
		
		repaint() ;
		return true ;
	}
	public synchronized boolean mouseUp(Event e, int x, int y){
		actif = false ;
		repaint() ;
		return true ;
	}
}
